#define NBYTES  98
#define NLENGTHS  4

static const uint8_t PROGMEM puzzle[NBYTES] = { 
  0xcc,0x30,0xf7,0x86,0xd0,0x45,0x32,0x69,0x1e,0x5f,0xe8,0x3c,0x72,0xd8,0xb5,0x8b,
  0xb4,0x3e,0xa6,0xc2,0x1c,0xfd,0xa7,0xa6,
  0xd6,0x26,0xe2,0x82,0xdd,0x59,0x3f,0x6c,0x03,0x48,0xf0,0x2e,0x7e,0xc0,0xbf,0x89,
  0xaf,0x3f,0xbc,0xde,0x10,0xe6,0xb4,0xb7,0xeb,
  0xca,0x2d,0xf1,0x93,0xdb,0x5f,0x32,0x60,0x06,0x59,0xfa,0x3c,0x78,0xd8,0xbf,0x8d,
  0xb7,0x33,0xbc,0xde,0x0c,0xfb,0xa4,0xb0,
  0xc3,0x2c,0xe6,0x93,0xca,0x42,0x39,0x60,0x01,0x53,0xe0,0x26,0x63,0xc5,0xb3,0x81,
  0xba,0x33,0xa0,0xc5,0x10,0xe6,0xb4,0xb7,0xeb
};

int lengths[NLENGTHS] = {24, 25, 24, 25};

const int timeDelay = 750;

int pinR = 1;
int pinY = 3;
int pinB = 4;
int pinG = 0;

int allPins[] = {pinR, pinG, pinB, pinY};
int nPins = 4;

void setup() {
  pinMode(pinR, OUTPUT);
  pinMode(pinG, OUTPUT);
  pinMode(pinB, OUTPUT);
  pinMode(pinY, OUTPUT);
  clearAll();
}

void loop() {
  setAll();
  delay(1000);
  clearAll();
  delay(1000);
  displayCount();
  clearAll();
  delay(1000);
  int k = 0;
  for (int i=0; i < NLENGTHS; i++) {
    for (int j=0; j < lengths[i]; j++) {
      uint8_t b = pgm_read_byte_near(puzzle + k++);
      displayBits(b >> 4);
      delay(timeDelay);
      displayBits(b & 0xF);
      delay(timeDelay);
      clearAll();
      delay(timeDelay);
    }
    clearAll();
    delay(1000);
    for (int l=0; l<16; l++) {
      setAll();
      delay(100);
      clearAll();
      delay(100);
    }
    clearAll();
    delay(1000);
  }
  clearAll();
  delay(2000);
}

void clearAll() {
  for (int i=0; i<nPins; i++) {
    digitalWrite(allPins[i], HIGH);
  };
}

void setAll() {
  for (int i=0; i<nPins; i++) {
    digitalWrite(allPins[i], LOW);
  };
}

void displayBits(uint8_t b) {
  b = ~b;
  digitalWrite(pinB, (b >> 3) & 0x01);
  digitalWrite(pinG, (b >> 2) & 0x01);
  digitalWrite(pinR, (b >> 1) & 0x01);
  digitalWrite(pinY, b & 0x01);
}

void displayCount(void) {
  for (uint8_t c = 0; c < 16; c++) {
    displayBits(c);
    delay(200);
  }
}

