#define NBYTES  139

static const uint8_t PROGMEM puzzle[NBYTES] = { 
    0xfa,0xf0,0xf1,0xf0,0x88,0xf0,0x72,0xb0,0xec,0xd0,0xfc,0xe0,0x31,0xfa,0xf0,0x10,
    0xf3,0x70,0xe4,0xf1,0xfa,0xb1,0x54,0xf2,0xfd,0xf2,0x20,0xf4,0xf0,0xd0,0xfe,0xe0,
    0x74,0xea,0xb0,0xd8,0xf4,0xe0,0xf5,0x72,0xb0,0xdc,0xf1,0xfc,0xe0,0x51,0xf8,0x90,
    0xff,0xf0,0x73,0xf0,0xaa,0xf4,0x50,0xe0,0xfc,0xf0,0xd5,0xf0,0x32,0xe4,0xf1,0x70,
    0xd8,0xf4,0xf1,0xb8,0xc4,0xfb,0xf4,0x70,0xba,0xe4,0x73,0xf4,0xd0,0xe8,0xb2,0x71,
    0xfe,0xe0,0xf7,0xf0,0xdc,0xf0,0x22,0xf8,0xf3,0xf8,0x91,0xf0,0xe2,0x71,0x98,0xf0,
    0xff,0xf0,0x22,0xfc,0xd0,0xf7,0xf8,0xf2,0xa8,0xf4,0x50,0xf2,0xec,0xf1,0xba,0xf1,
    0x50,0xfa,0xb1,0xfe,0xe0,0xd5,0xf2,0x71,0xfc,0xf0,0xb1,0xd4,0x62,0xfc,0xf2,0xf0,
    0xfc,0xc0,0xba,0xf0,0x62,0x60,0x62,0x20,0x40,0x40,0x00
};

const int timeDelay = 100;

int pinR = 1;
int pinY = 3;
int pinB = 4;
int pinG = 0;

int allPins[] = {pinR, pinG, pinB, pinY};
int nPins = 4;

void setup() {
  pinMode(pinR, OUTPUT);
  pinMode(pinG, OUTPUT);
  pinMode(pinB, OUTPUT);
  pinMode(pinY, OUTPUT);
  clearAll();
}

void loop() {
  setAll();
  delay(1000);
  clearAll();
  delay(2000);
  for (int i=0; i < NBYTES; i++) {
    uint8_t b = pgm_read_byte_near(puzzle + i);
    displayBits(b >> 4);
    delay(timeDelay);
    displayBits(b & 0xF);
    delay(timeDelay);
  }
  clearAll();
  delay(2000);
}

void clearAll() {
  for (int i=0; i<nPins; i++) {
    digitalWrite(allPins[i], HIGH);
  };
}

void setAll() {
  for (int i=0; i<nPins; i++) {
    digitalWrite(allPins[i], LOW);
  };
}

void displayBits(uint8_t b) {
  b = ~b;
  digitalWrite(pinR, (b >> 3) & 0x01);
  digitalWrite(pinG, (b >> 2) & 0x01);
  digitalWrite(pinB, (b >> 1) & 0x01);
  digitalWrite(pinY, b & 0x01);
}


